"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const Delimiters = require("../tokens/delimiters");
const Keywords = require("../tokens/keywords");
const TypeReferenceTokens = require("../tokens/type_reference_tokens");
const GenericTokens = require("../tokens/generic_tokens");
const MethodParameterTokens = require("../tokens/method_parameter_tokens");
const AttributeEmitter = require("./attribute_emitter");
function emit(writer, delegate) {
    const { attributes, access, result, name, generics, parameters } = delegate;
    const accessTokens = access ? [access, Delimiters.space] : [];
    const resultTokens = TypeReferenceTokens.emit(result);
    const genericTokens = GenericTokens.emit(generics);
    const methodParameterTokens = MethodParameterTokens.emit(parameters);
    AttributeEmitter.emitMany(writer, attributes);
    writer
        .outputTabs()
        .write(...accessTokens)
        .write(Keywords.delegate, Delimiters.space)
        .write(...resultTokens)
        .write(Delimiters.space)
        .write(name)
        .write(...genericTokens)
        .write(...methodParameterTokens)
        .write(Delimiters.semicolon)
        .writeLineNoTabs();
}
exports.emit = emit;
